{   The_GUI - Frontend for a couple of command-line tools
    Copyright (C) 2004  Spasic Boban (spasic7@hotmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA }

unit CD_op_unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrUtils, DosCommand, Spin, ExtCtrls;

type
  TCD_Operations = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    Memo1: TMemo;
    DosCommand1: TDosCommand;
    DosCommand2: TDosCommand;
    Panel1: TPanel;
    btBurn: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel2: TPanel;
    btFormat: TButton;
    btQuickFormat: TButton;
    ComboBox2: TComboBox;
    cbSimulate: TCheckBox;
    seSpeed: TSpinEdit;
    Label6: TLabel;
    btClose: TButton;
    Panel3: TPanel;
    Label3: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label8: TLabel;
    Panel4: TPanel;
    btRead: TButton;
    cbDontFinalize: TCheckBox;
    cbBurnFree: TCheckBox;
    btFinalize: TButton;
    procedure FormActivate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure DosCommand2Terminated(Sender: TObject; ExitCode: Cardinal);
    procedure DosCommand1Terminated(Sender: TObject; ExitCode: Cardinal);
    procedure seSpeedExit(Sender: TObject);
    procedure btBurnClick(Sender: TObject);
    procedure btFormatClick(Sender: TObject);
    procedure btQuickFormatClick(Sender: TObject);
    procedure btReadClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure btFinalizeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CD_Operations: TCD_Operations;
  isCDR: boolean;
  isCDRW: boolean;
  max_write_speed: string;
  cdrecordFound: boolean;
  readcdFound: boolean;
  debug: boolean;
const
  el = #13 + #10;
  nl = '*****  ';

implementation

uses console_capture, debug_unit;

{$R *.dfm}

function filter_devices(ulaz: string): boolean;
begin
  if Pos('CD-ROM', ulaz) <> 0 then
    result := true
  else
    result := false;
end;

function filter_device_names(ulaz: string): string;
var
  temp: string;
  temp2: string;
  firstquota: integer;
  secondquota: integer;
begin
  firstquota := Pos(chr(39), ulaz);
  secondquota := PosEx(chr(39), ulaz, (firstquota + 1));
  temp := MidStr(ulaz, (firstquota + 1), (secondquota - firstquota));
  temp2 := MidStr(ulaz, (firstquota), (secondquota - firstquota));
  ulaz := AnsiReplaceStr(ulaz, temp2, '');
  firstquota := Pos(chr(39), ulaz) + 2;
  secondquota := PosEx(chr(39), ulaz, (firstquota + 1));
  temp := temp + MidStr(ulaz, (firstquota + 1), (secondquota - firstquota - 1));
  temp := AnsiReplaceStr(temp, chr(39), '');
  result := temp;
end;

function device_ID(ulaz: string): string;
var
  temp: string;
  position: integer;
begin
  position := pos(',', ulaz);
  temp := '';
  temp := MidStr(ulaz, position - 1, 5);
  result := temp;
end;

procedure TCD_Operations.FormActivate(Sender: TObject);
var
  CDRecordFind: string;
  ReadcdFind: string;
  apppath: string;
begin
  if debug = true then
  begin
    debug_win.Memo1.Text := debug_win.Memo1.Text + el + nl +
      'entering CD operations module' + el;
  end;
  apppath := ExtractFilePath(Application.EXEName);
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  cdrecordFound := false;
  readcdFound := false;
  CDRecordFind := FileSearch('cdrecord.exe', apppath);
  if CDRecordFind = '' then
  begin
    ShowMessage('Couldn''t find cdrecord.exe . Please put cdrecord.exe in The_GUI folder');
    cdrecordFound := false;
  end
  else
    cdrecordFound := true;
  ReadcdFind := FileSearch('readcd.exe', apppath);
  if ReadcdFind = '' then
  begin
    ShowMessage('Couldn''t find readcd.exe . Please put readcd.exe in The_GUI folder');
    readcdFound := false;
  end
  else
    readcdFound := true;
  if cdrecordFound = true then
  begin
    Memo1.Clear;
    if debug = true then
    begin
      debug_win.Memo1.Text := debug_win.Memo1.Text + el + nl + (apppath +
        'cdrecord -scanbus') + el;
    end;
    DosCommand2.OutputLines := debug_win.Memo1.Lines;
    DosCommand2.CommandLine := (apppath + 'cdrecord -scanbus');
    DosCommand2.Execute;

  end;
  if (cdrecordFound = false) and (readcdFound = false) then
    close;
end;

procedure TCD_Operations.ComboBox1Change(Sender: TObject);
begin
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  Memo1.Clear;
  DosCommand1.OutputLines := Memo1.Lines;
  DosCommand1.CommandLine := ('cdrecord dev=' + device_id(combobox1.text) +
    ' -prcap');
  DosCommand1.Execute;
  Label3.Caption := device_id(combobox1.Text);
end;

procedure TCD_Operations.DosCommand2Terminated(Sender: TObject; ExitCode:
  Cardinal);
var
  counter: integer;
begin
  counter := 0;
  Combobox1.Clear;
  while counter < DosCommand2.Lines.Count do
  begin
    if filter_devices(DosCommand2.Lines.ValueFromIndex[counter]) = true then
      Combobox1.Items.Add('[' +
        device_id(DosCommand2.Lines.ValueFromIndex[counter]) + '] ' +
        filter_device_names(DosCommand2.Lines.ValueFromIndex[counter]));
    counter := counter + 1;
  end;
  if combobox1.Items.Strings[0] <> '' then
  begin
    Label3.Caption := device_id(combobox1.Text);
  end
  else
    ShowMessage('No CD-ROM devices found');
end;

procedure TCD_Operations.DosCommand1Terminated(Sender: TObject;
  ExitCode: Cardinal);
var
  counter: integer;
begin
  counter := 0;
  isCDR := false;
  isCDRW := false;
  max_write_speed := '';
  while counter < DosCommand1.Lines.Count do
  begin
    if AnsiContainsStr(DosCommand1.Lines.ValueFromIndex[counter],
      'Does write CD-R media') = true then
      isCDR := true;
    if AnsiContainsStr(DosCommand1.Lines.ValueFromIndex[counter],
      'Does write CD-RW media') = true then
      isCDRW := true;
    counter := counter + 1;
  end;
  counter := 0;
  while counter < CD_operations.DosCommand1.Lines.Count do
  begin
    if AnsiContainsStr(CD_operations.DosCommand1.Lines.ValueFromIndex[counter],
      'Maximum write speed') = true then
    begin
      max_write_speed :=
        MidStr(CD_operations.DosCommand1.Lines.ValueFromIndex[counter],
        (pos(',',
        CD_operations.DosCommand1.Lines.ValueFromIndex[counter]) - 3), 2);
    end;
    counter := counter + 1;
  end;
  if isCDR = false then
  begin
    btBurn.enabled := false;
    seSpeed.enabled := false;
    cbSimulate.Enabled := false;
    cbDontFinalize.Enabled := false;
    cbBurnFree.Enabled := false;
    btFormat.Enabled := false;
    btQuickFormat.Enabled := false;
    ComboBox2.Enabled := false;
    label5.Caption := '';
    btFinalize.enabled := false;
    if readcdFound = true then
      btRead.Enabled := true;
  end;
  if (isCDR = true) and (cdrecordFound = true) then
  begin
    btBurn.enabled := true;
    seSpeed.enabled := true;
    cbSimulate.Enabled := true;
    cbDontFinalize.Enabled := true;
    cbBurnFree.Enabled := true;
    btFormat.Enabled := false;
    btQuickFormat.Enabled := false;
    ComboBox2.Enabled := false;
    label5.Caption := max_write_speed;
    seSpeed.MaxValue := StrToInt(max_write_speed);
    seSpeed.Value := StrToInt(max_write_speed);
    btFinalize.enabled := true;
    if readcdFound = true then
      btRead.Enabled := true;
  end;
  if (isCDRW = true) and (cdrecordFound = true) then
  begin
    btBurn.enabled := true;
    seSpeed.enabled := true;
    cbSimulate.Enabled := true;
    cbDontFinalize.Enabled := true;
    cbBurnFree.Enabled := true;
    btFormat.Enabled := true;
    btQuickFormat.Enabled := true;
    ComboBox2.Enabled := true;
    label5.Caption := max_write_speed;
    seSpeed.MaxValue := StrToInt(max_write_speed);
    seSpeed.Value := StrToInt(max_write_speed);
    btFinalize.enabled := true;
    if readcdFound = true then
      btRead.Enabled := true;
  end;
  cd_operations.Refresh;
end;

procedure TCD_Operations.seSpeedExit(Sender: TObject);
begin
  if seSpeed.Value > seSpeed.MaxValue then
    seSpeed.Value := seSpeed.MaxValue;
end;

procedure TCD_Operations.btBurnClick(Sender: TObject);
var
  ISOfile: string;
  options: string;
begin
  if OpenDialog1.Execute then
  begin
    ISOfile := OpenDialog1.FileName;
    Setcurrentdir(ExtractFilePath(Application.EXEName));
    options := '';
    options := 'dev=' + label3.Caption;
    if cbSimulate.Checked = true then
      options := options + ' -dummy ';
    if cbDontFinalize.Checked = true then
      options := options + ' -nofix ';
    if cbBurnFree.Checked = true then
      options := 'driveropts=burnfree ' + options;
    options := options + 'speed=' + IntToStr(seSpeed.Value) + ' ';
    options := options + '"' + ISOfile + '"';
    console_capture.phantom := false;
    console.Memo1.Clear;
    console.DosCommand1.OutputLines := console.Memo1.Lines;
    console.DosCommand1.CommandLine := ('cdrecord ' + '-eject ' + options +
      ' gracetime=1');
    console.DosCommand1.Execute;
    console.ShowModal;
    if debug = true then
    begin
      debug_win.Memo1.Text := debug_win.Memo1.Text + el + nl + ('cdrecord ' +
        '-eject ' + options + ' gracetime=1') + el;
      debug_win.Memo1.text := debug_win.Memo1.text + console.Memo1.text;
    end;
  end;
end;

procedure TCD_Operations.btFormatClick(Sender: TObject);
begin
  if
    MessageDlg('This operation makes permanent changes. Are you sure you want to preceed? ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    Setcurrentdir(ExtractFilePath(Application.EXEName));
    console_capture.phantom := false;
    console.Memo1.Clear;
    console.DosCommand1.OutputLines := console.Memo1.Lines;
    console.DosCommand1.CommandLine := ('cdrecord ' + '-eject ' + 'dev=' +
      label3.Caption + ' -format');
    console.DosCommand1.Execute;
    console.ShowModal;
    if debug = true then
    begin
      debug_win.Memo1.Text := debug_win.Memo1.Text + el + nl + ('cdrecord ' +
        '-eject ' + 'dev=' + label3.Caption + ' -format') + el;
      debug_win.Memo1.text := debug_win.Memo1.text + console.Memo1.text;
    end;
  end;
end;

procedure TCD_Operations.btQuickFormatClick(Sender: TObject);
begin
  if
    MessageDlg('This operation makes permanent changes. Are you sure you want to preceed? ', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    Setcurrentdir(ExtractFilePath(Application.EXEName));
    console_capture.phantom := false;
    console.Memo1.Clear;
    console.DosCommand1.OutputLines := console.Memo1.Lines;
    console.DosCommand1.CommandLine := ('cdrecord ' + '-eject ' + 'dev=' +
      label3.Caption + ' blank=' + combobox2.Text);
    console.DosCommand1.Execute;
    console.ShowModal;
    if debug = true then
    begin
      debug_win.Memo1.Text := debug_win.Memo1.Text + el + nl + ('cdrecord ' +
        '-eject ' + 'dev=' + label3.Caption + ' blank=' + combobox2.Text) + el;
      debug_win.Memo1.text := debug_win.Memo1.text + console.Memo1.text;
    end;
  end;
end;

procedure TCD_Operations.btReadClick(Sender: TObject);
var
  ISOfile: string;
  f: textfile;
  buffer: string;
begin
  if SaveDialog1.Execute then
  begin
    ISOfile := SaveDialog1.FileName;
    ISOfile := '"' + ISOfile + '"';
    Setcurrentdir(ExtractFilePath(Application.EXEName));
    console_capture.phantom := false;
    console.Memo1.Clear;
    console.DosCommand1.OutputLines := console.Memo1.Lines;
    console.DosCommand1.CommandLine := ('readcd ' + 'dev=' + label3.Caption +
      ' f=' + ISOfile);
    console.DosCommand1.Execute;
    console.ShowModal;
    if debug = true then
    begin
      AssignFile(f, 'capture.tmp');
      reset(f);
      debug_win.Memo1.Text := debug_win.Memo1.Text + el + nl + ('readcd ' +
        'dev=' + label3.Caption + ' f=' + ISOfile) + el;
      while not EOF(F) do
      begin
        Readln(F, buffer);
        debug_win.Memo1.text := debug_win.Memo1.text + buffer + #13 + #10;
      end;
      closefile(f);
    end;

  end;
end;

procedure TCD_Operations.btCloseClick(Sender: TObject);
begin
  close;
end;

procedure TCD_Operations.btFinalizeClick(Sender: TObject);
begin
  Setcurrentdir(ExtractFilePath(Application.EXEName));
  console_capture.phantom := false;
  console.Memo1.Clear;
  console.DosCommand1.OutputLines := console.Memo1.Lines;
  console.DosCommand1.CommandLine := ('cdrecord ' + 'dev=' + label3.Caption +
    ' -fix');
  console.DosCommand1.Execute;
  console.ShowModal;
  if debug = true then
  begin
    debug_win.Memo1.Text := debug_win.Memo1.Text + el + nl + ('cdrecord ' +
      'dev=' + label3.Caption + ' -fix') + el;
    debug_win.Memo1.text := debug_win.Memo1.text + console.Memo1.text;
  end;
end;

end.

