{   The_GUI - Frontend for a couple of command-line tools
    Copyright (C) 2004  Spasic Boban (spasic7@hotmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA }

unit console_capture;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DosCommand, StrUtils;

type
  Tconsole = class(TForm)
    DosCommand1: TDosCommand;
    Memo1: TMemo;
    procedure DosCommand1Terminated(Sender: TObject; ExitCode: Cardinal);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure Memo1Change(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  console: Tconsole;
  phantom: boolean;
  debug: boolean;
  f: textfile;
  win98: boolean;

implementation

{$R *.dfm}

procedure ScrollMemoDown(Memo: TMemo);
begin
  SendMessage(Memo.Handle, { HWND of the Memo Control }
    WM_VSCROLL, { Windows Message }
    SB_PAGEDOWN, { Scroll Command }
    0) { Not Used }
end;

procedure ScrollMemoUp(Memo: TMemo);
begin
  SendMessage(Memo.Handle, { HWND of the Memo Control }
    WM_VSCROLL, { Windows Message }
    SB_PAGEUP, { Scroll Command }
    0); { Not Used }
end;

procedure Tconsole.DosCommand1Terminated(Sender: TObject;
  ExitCode: Cardinal);
begin
  if phantom = false then
    Application.MessageBox(
      PChar(Format('Process finished!', [ExitCode])),
      'Info', MB_ICONINFORMATION);
  close;
end;

procedure Tconsole.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if win98 = true then
  begin
    Append(f);
    Writeln(f, memo1.text);
    Flush(f);
    CloseFile(f);
  end;
  DosCommand1.Stop;
end;

procedure Tconsole.FormActivate(Sender: TObject);
begin
  if phantom = true then
    console.Hide;
  if win98 = true then
  begin
    Setcurrentdir(ExtractFilePath(Application.EXEName));
    AssignFile(f, 'capture.tmp');
  end;
end;

procedure Tconsole.Memo1Change(Sender: TObject);
begin
  if win98 = true then
  begin
    Append(f);
    if length(memo1.Text) > 64000 then
    begin
      Writeln(f, memo1.text);
      memo1.Clear;
      Flush(f);
    end;
  end;
  ScrollMemoDown(Memo1);
end;

end.

