{   The_GUI - Frontend for a couple of command-line tools
    Copyright (C) 2004  Spasic Boban (spasic7@hotmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA }

unit sorter;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Grids, ValEdit, ShellAPI, StrUtils,
  ShellCtrls, ExtCtrls;

type
  Tsorter_form = class(TForm)
    ListBox1: TListBox;
    ShellTreeView1: TShellTreeView;
    Button11: TButton;
    Edit1: TEdit;
    ValueListEditor1: TValueListEditor;
    UpDown1: TUpDown;
    Button6: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Label6: TLabel;
    Button3: TButton;
    Memo1: TMemo;
    Button4: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button16: TButton;
    Button17: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Button1: TButton;
    ListBox2: TListBox;
    Edit4: TEdit;
    Edit5: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Button2: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure ShellTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Button6Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure ValueListEditor1Click(Sender: TObject);
    procedure ValueListEditor1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ShellTreeView1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  sorter_form: Tsorter_form;

implementation

{$R *.dfm}

function WinToLin(ulaz: string): string;
var
  temp: string;
begin
  temp := ulaz;
  temp := AnsiReplaceStr(temp, '\', '/');
  result := temp;
end;

function LinToWin(ulaz: string): string;
var
  temp: string;
begin
  temp := ulaz;
  temp := AnsiReplaceStr(temp, '/', '\');
  result := temp;
end;

function FindValue(ulaz: string): string;
var
  inputLen: integer;
  counter: integer;
  trimLen: integer;
begin
  while (pos(' ', ulaz)) <> 0 do
  begin
    counter := pos(' ', ulaz);
    inputLen := length(ulaz);
    trimLen := inputLen - counter;
    ulaz := RightStr(ulaz, trimLen);
  end;
  result := ulaz;
end;

function FindKey(ulaz: string): string;
var
  temp: string;
  inputLen: integer;
  counter: integer;
  trimLen: integer;
begin
  temp := ulaz;
  while (pos(' ', ulaz)) <> 0 do
  begin
    counter := pos(' ', ulaz);
    inputLen := length(ulaz);
    trimLen := inputLen - counter;
    ulaz := RightStr(ulaz, trimLen);
  end;
  temp := StringReplace(temp, (' ' + ulaz), '', [rfReplaceAll]);
  result := temp;
end;

function FindKey2(ulaz: string): string;
var
  inputLen: integer;
  counter: integer;
  trimLen: integer;
begin
  counter := pos(' ', ulaz);
  inputLen := length(ulaz);
  trimLen := inputLen - counter;
  ulaz := RightStr(ulaz, trimLen);
  ulaz := trim(ulaz);
  result := ulaz;
end;

function FindValue2(ulaz: string): string;
var
  counter: integer;
begin
  counter := pos(' ', ulaz);
  ulaz := LeftStr(ulaz, counter);
  ulaz := trim(ulaz);
  result := ulaz;
end;

function PreSort(ulaz: string): string;
var
  max: int64;
  temp: int64;
begin
  max := 2147483647;
  temp := StrToInt64(ulaz) - max;
  ulaz := IntToStr(temp);
  while (length(ulaz)) < 10 do
  begin
    ulaz := '0' + ulaz;
  end;
  result := ulaz;
end;

function PostSort(ulaz: string): string;
var
  max: int64;
  temp: int64;
begin
  max := 2147483647;
  temp := StrToInt64(ulaz) + max;
  ulaz := IntToStr(temp);

  while pos('0', ulaz) = 1 do
  begin
    ulaz := rightStr(ulaz, (length(ulaz) - 1));
  end;
  if length(ulaz) = 0 then
    ulaz := '0';
  result := ulaz;
end;

function ReplaceTabs(ulaz: string): string;
begin
  result := StringReplace(ulaz, (chr(9)), ' ', [rfReplaceAll]);
end;

procedure RenameDir(DirFrom, DirTo: string);
var
  shellinfo: TSHFileOpStruct;
begin
  with shellinfo do
  begin
    Wnd := 0;
    wFunc := FO_RENAME;
    pFrom := PChar(DirFrom);
    pTo := PChar(DirTo);
    {fFlags := FOF_FILESONLY or FOF_ALLOWUNDO or
              FOF_SILENT or FOF_NOCONFIRMATION;}
    fFlags := FOF_ALLOWUNDO or
      FOF_SILENT or FOF_NOCONFIRMATION;
  end;
  SHFileOperation(shellinfo);
  if SHFileOperation(shellinfo) = 1 then
    MessageDlg('folder not renamed', mtInformation, [mbOk], 0);
end;

function FindFiles(Directory: string; InclAttr, ExclAttr: Integer;
  const SubDirs: Boolean; const Files: TStrings): Integer;
var
  SearchRec: TSearchRec;
begin
  Directory := IncludeTrailingPathDelimiter(Directory);
  FillChar(SearchRec, SizeOf(SearchRec), 0);
  if FindFirst(Directory + '*.*', faAnyFile, SearchRec) = 0 then
  begin
    try
      repeat
        if (SearchRec.Name <> '.') and (SearchRec.Name <> '..') then
          if ((SearchRec.Attr and InclAttr > 0) or ((SearchRec.Attr = 0) and
            (InclAttr <> faDirectory))) and
            (SearchRec.Attr and ExclAttr = 0) then
          begin
            Files.Add(Directory + SearchRec.Name);
            if SubDirs then
              if SearchRec.Attr and faDirectory <> 0 then
                FindFiles(Directory + SearchRec.Name, InclAttr, ExclAttr,
                  SubDirs, Files);
          end;
      until
        FindNext(SearchRec) <> 0;
    finally
      FindClose(SearchRec);
    end;
  end;
  Result := Files.Count;
end;

procedure Tsorter_form.Button4Click(Sender: TObject); //delete row
begin
  if ValueListEditor1.Row <> 1 then
    ValueListEditor1.DeleteRow(ValueListEditor1.Row)
  else if ValueListEditor1.Keys[1] <> '' then
  begin
    ValueListEditor1.Keys[1] := '';
    ValueListEditor1.Values[ValueListEditor1.Keys[1]] := '';
  end;
  ValueListEditor1.Refresh;
end;

procedure Tsorter_form.Button3Click(Sender: TObject); //save list
var
  counter: integer;
  outputfile: string;
  itemCount: integer;
  keyName: string;
  keyValue: string;
begin
  if SaveDialog1.Execute then
  begin
    outputfile := SaveDialog1.FileName;
    Memo1.Text := '';
    itemcount := ValueListEditor1.RowCount - 1;
    for counter := 1 to itemCount do
    begin
      keyName := ValueListEditor1.Keys[counter];
      keyValue := ValueListEditor1.values[valuelisteditor1.Keys[counter]];
      Memo1.Text := memo1.Text + keyName + ' ' + keyValue + chr(13) + chr(10);

    end;
    memo1.Lines.SaveToFile(outputfile);
  end;
end;

procedure Tsorter_form.Button11Click(Sender: TObject); //close
begin
  close;
end;

procedure Tsorter_form.ShellTreeView1Change(Sender: TObject;
  Node: TTreeNode);
var
  sl: TStringList;
  include: integer;
  exclude: integer;
  subfolders: boolean;
  rootfolder: string;
begin
  Edit1.Text := ShellTreeView1.Path;
  ListBox1.Clear;
  exclude := faDirectory;
  rootfolder := ShellTreeView1.path;
  include := {faDirectory or} faAnyFile;
  subfolders := false;
  sl := TStringList.Create;
  try
    FindFiles(rootfolder, include, exclude, subfolders, sl);
    Listbox1.Items.AddStrings(sl);
  finally
    sl.Free;
  end;
end;

procedure Tsorter_form.UpDown1Click(Sender: TObject; Button: TUDBtnType);
var
  weight: string;
  weightInt: integer;
  i: integer;

begin
  if TryStrToInt(combobox1.Items[combobox1.ItemIndex], i) = true then
  begin
    if
      TryStrToInt(ValueListEditor1.values[valuelisteditor1.Keys[valuelisteditor1.Row]], i) = true then
    begin
      weight :=
        ValueListEditor1.values[valuelisteditor1.Keys[valuelisteditor1.Row]];
      if button = btNext then
      begin
        weightInt := strtoint(weight);
        if weightInt > (2147483647 -
          StrToInt(combobox1.Items[combobox1.ItemIndex])) then
          weightInt := 2147483647
        else
          weightInt := weightInt +
            StrToInt(combobox1.Items[combobox1.ItemIndex]);
        weight := inttostr(weightInt);
        ValueListEditor1.values[valuelisteditor1.Keys[valuelisteditor1.Row]] :=
          weight;
      end;
      if button = btPrev then
      begin
        weightInt := strtoint(weight);
        if weightInt < (-2147483647 +
          StrToInt(combobox1.Items[combobox1.ItemIndex])) then
          weightInt := -2147483647
        else
          weightInt := weightInt -
            StrToInt(combobox1.Items[combobox1.ItemIndex]);
        weight := inttostr(weightInt);
        ValueListEditor1.values[valuelisteditor1.Keys[valuelisteditor1.Row]] :=
          weight;
      end;
    end;
  end;
end;

procedure Tsorter_form.Button6Click(Sender: TObject); // +/-
var
  weight: string;
  weightInt: integer;
  i: integer;
begin
  if
    TryStrToInt(ValueListEditor1.values[valuelisteditor1.Keys[valuelisteditor1.Row]], i) = true then
  begin
    weight :=
      ValueListEditor1.values[valuelisteditor1.Keys[valuelisteditor1.Row]];
    weightInt := strtoint(weight);
    weightInt := -weightInt;
    weight := inttostr(weightInt);
    ValueListEditor1.values[valuelisteditor1.Keys[valuelisteditor1.Row]] :=
      weight;
  end;
end;

procedure Tsorter_form.Button13Click(Sender: TObject); // add to list
var
  counter: integer;
  initialWeight: integer;
  step: integer;
  FileWeight: integer;
  flag: integer;
  i: integer;
begin
  flag := 0;
  step := 1;
  initialweight := 0;
  if Edit3.Text <> '' then
    if TryStrToInt(Edit3.Text, i) = true then
      step := StrToInt(Edit3.Text);
  if Edit2.Text = '' then
  begin
    if ValueListEditor1.Values[valuelisteditor1.Keys[(valuelisteditor1.RowCount
      - 1)]] = '' then
      initialWeight := 0;
    if ValueListEditor1.Values[valuelisteditor1.Keys[(valuelisteditor1.RowCount
      - 1)]] <> '' then
      initialWeight :=
        StrToInt(ValueListEditor1.Values[valuelisteditor1.Keys[(valuelisteditor1.RowCount - 1)]]) + step;
  end
  else if TryStrToInt(Edit2.text, i) = true then
    initialWeight := strtoInt(Edit2.Text);
  FileWeight := initialWeight;
  counter := 0;
  while counter < (Listbox1.Count) do
  begin
    if listbox1.Selected[counter] then
    begin
      ValueListEditor1.InsertRow((WinToLin(Listbox1.Items.Strings[counter])),
        (IntToStr(FileWeight)), true);
      FileWeight := FileWeight + step;
      Edit2.Text := inttostr(FileWeight);
      Edit3.Text := inttostr(step);
      flag := 1;
    end;
    counter := counter + 1;
  end;
  if flag = 0 then
  begin
    step := 1;
    initialweight := 0;
    if Edit3.Text <> '' then
      step := StrToInt(Edit3.Text);
    if Edit2.Text = '' then
    begin
      if ValueListEditor1.Values[valuelisteditor1.Keys[(valuelisteditor1.RowCount
        - 1)]] = '' then
        initialWeight := 0;
      if ValueListEditor1.Values[valuelisteditor1.Keys[(valuelisteditor1.RowCount
        - 1)]] <> '' then
        initialWeight :=
          StrToInt(ValueListEditor1.Values[valuelisteditor1.Keys[(valuelisteditor1.RowCount - 1)]]) + step;
    end
    else
      initialWeight := strtoInt(Edit2.Text);
    FileWeight := initialWeight;
    ValueListEditor1.InsertRow((WinToLin(ShellTreeView1.Path)),
      (IntToStr(FileWeight)), true);
    FileWeight := FileWeight + step;
    Edit2.Text := inttostr(FileWeight);
    Edit3.Text := inttostr(step);
  end;
end;

procedure Tsorter_form.Button15Click(Sender: TObject); //import list
var
  counter: integer;
  inputKey: string;
  inputValue: string;
  buffer1: string;

begin
  button17.Click;
  if OpenDialog1.Execute then
  begin
    counter := 0;
    Memo1.Clear;
    Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
    while counter < Memo1.Lines.Count do
    begin
      buffer1 := Memo1.Lines[counter];
      buffer1 := ReplaceTabs(buffer1);
      inputValue := FindValue(buffer1);
      inputKey := FindKey(buffer1);
      if (rightstr(edit1.Text, 1)) <> '\' then
        edit1.Text := edit1.Text + '\';
      inputKey := WinToLin(Edit1.Text + inputKey);
      ValueListEditor1.InsertRow(inputKey, inputValue, true);
      counter := counter + 1;
    end;
  end;
end;

procedure Tsorter_form.Button14Click(Sender: TObject); //load list
var
  counter: integer;
  inputKey: string;
  inputValue: string;
  buffer1: string;

begin
  button17.Click;
  if OpenDialog1.Execute then
  begin
    counter := 0;
    Memo1.Clear;
    Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
    while counter < Memo1.Lines.Count do
    begin
      buffer1 := Memo1.Lines[counter];
      buffer1 := ReplaceTabs(buffer1);
      buffer1 := WinToLin(buffer1);
      inputValue := FindValue(buffer1);
      inputKey := FindKey(buffer1);
      ValueListEditor1.InsertRow(inputKey, inputValue, true);
      counter := counter + 1;
    end;
  end;
end;

procedure Tsorter_form.Button16Click(Sender: TObject); //export list
var
  counter: integer;
  outputfile: string;
  itemCount: integer;
  keyName: string;
  keyValue: string;
begin
  if SaveDialog1.Execute then
  begin
    outputfile := SaveDialog1.FileName;
    Memo1.Text := '';
    itemcount := ValueListEditor1.RowCount - 1;
    for counter := 1 to itemCount do
    begin
      keyName := ValueListEditor1.Keys[counter];
      keyName := StringReplace(keyName, Edit1.Text, '', [rfReplaceAll]);
      keyValue := ValueListEditor1.values[valuelisteditor1.Keys[counter]];
      Memo1.Text := memo1.Text + keyName + ' ' + keyValue + chr(13) + chr(10);
    end;
    memo1.Lines.SaveToFile(outputfile);
  end;
end;

procedure Tsorter_form.Button17Click(Sender: TObject); //Clear List
var
  counter: integer;

begin
  counter := (ValueListEditor1.RowCount - 1);
  if counter > 1 then
  begin
    while counter > 0 do
    begin
      ValueListEditor1.DeleteRow(counter);
      counter := counter - 1;
    end;
  end;
end;

procedure Tsorter_form.ValueListEditor1Click(Sender: TObject);
var
  i: integer;
  j: integer;
begin
  if
    TryStrToInt(ValueListEditor1.Values[valuelisteditor1.Keys[valuelisteditor1.row]], i) = true then
    if TryStrToInt(Edit3.Text, j) = true then
      Edit2.Text := IntToStr(i + j)
    else
      Edit2.Text := IntToStr(i + 1);
end;

procedure Tsorter_form.ValueListEditor1KeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var
  i: integer;
  j: integer;
begin
  if
    TryStrToInt(ValueListEditor1.Values[valuelisteditor1.Keys[valuelisteditor1.row]], i) = true then
    if TryStrToInt(Edit3.Text, j) = true then
      Edit2.Text := IntToStr(i + j)
    else
      Edit2.Text := IntToStr(i + 1);
end;

procedure Tsorter_form.ShellTreeView1Click(Sender: TObject);
begin
  ListBox1.ClearSelection;
end;

procedure Tsorter_form.Button1Click(Sender: TObject); // sort
var
  tempkey: string;
  tempvalue: string;
  counter: integer;
  tempstring: string;
  i: integer;

begin
  if
    TryStrToInt(ValueListEditor1.values[valuelisteditor1.Keys[valuelisteditor1.Row]], i) = true then
  begin
    ListBox2.Clear;
    counter := 1;
    while counter < (ValueListEditor1.RowCount) do
    begin
      tempKey := ValueListEditor1.Keys[counter];
      tempValue := ValueListEditor1.Values[ValueListEditor1.Keys[counter]];
      tempString := (PreSort(tempValue) + ' ' + tempKey);
      ListBox2.Items.Add(TempString);
      counter := counter + 1;
    end;
    counter := (ValueListEditor1.RowCount - 1);
    if counter > 1 then
    begin
      while counter > 0 do
      begin
        ValueListEditor1.DeleteRow(counter);
        counter := counter - 1;
      end;
    end;
    counter := 0;
    while counter < ListBox2.Count do
    begin
      tempKey := FindKey2(Listbox2.Items.Strings[counter]);
      tempValue := PostSort(FindValue2(Listbox2.Items.Strings[counter]));
      ValueListEditor1.InsertRow(tempKey, tempValue, true);
      counter := counter + 1;
    end;
  end;
end;

procedure Tsorter_form.Button2Click(Sender: TObject);
var
  counter: integer;
  itemCount: integer;
  keyName: string;
begin
  itemcount := ValueListEditor1.RowCount - 1;
  for counter := 1 to itemCount do
  begin
    keyName := ValueListEditor1.Keys[counter];
    keyName := StringReplace(keyName, Edit4.Text, Edit5.Text, [rfReplaceAll]);
    ValueListEditor1.Keys[counter] := keyName;
  end;
end;

end.

